#include <cstdio>
#include <cstdlib>
#include <vector>
using namespace std;

const char *dir = "tests";
static int subcases[10];
static vector<int> casy;

static void
vstup (int v, int m)
{
  char buf[1000];
  sprintf (buf, "%s/%02d.%c.in", dir, v, 'a' + subcases[v]++);
  FILE *f = fopen (buf, "w");
  fprintf (f, "%d %d\n", (int) casy.size () / 2, m);
  for (int c : casy)
    fprintf (f, "%d\n", c);
  fclose (f);
}

static void
gen_random (int n, int max_step)
{
  casy.clear ();
  int a = 1;
  for (int i = 0; i < 2 * n; i++)
    {
      casy.push_back (a);
      a += rand () % max_step + 1;
    }
}

static void
gen_full (int n)
{
  casy.clear ();
  for (int i = 0; i < 2 * n; i++)
    casy.push_back (i + 1);
}

int main (void)
{
  srand (100);

  /* Male pripady.  */
  casy = vector<int>{1,10};
  vstup (1, 8);
  vstup (1, 9);
  gen_random (10, 500);
  vstup (1, 2000);
  vstup (1, 9);

  /* Uplne zavorkovani.  */
  gen_full (198);
  vstup (2, 1000000);
  gen_full (199);
  vstup (2, 1000000);
  gen_random (200, 1000);
  vstup (2, 1000000);

  /* Uplne zavorkovani.  */
  gen_full (1998);
  vstup (3, 1000000);
  gen_full (1999);
  vstup (3, 1000000);
  gen_random (2000, 100);
  vstup (3, 1000000);

  /* Vstupy pro n^3 reseni.  */
  for (int v = 4; v < 7; v++)
    {
      gen_random (200, 500);
      vstup (v, 2000);
      gen_random (200, 500);
      vstup (v, 40000);
      gen_random (200, 500);
      vstup (v, 80000);
    }

  /* Vstupy pro n^2 reseni.  */
  for (int v = 7; v <= 10; v++)
    {
      gen_random (2000 - 500 * (10 - v), 450);
      vstup (v, 10000);
      gen_random (2000 - 500 * (10 - v), 450);
      vstup (v, 400000);
      gen_random (2000 - 500 * (10 - v), 450);
      vstup (v, 700000);
    }

  return 0;
}
